/* gl_tex2.c */
/* 5/12/00 
/* George Stetten and Vikram Chib */
/* adapted from SGI demo gl_tex.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <glut.h>
#include <vl/vl.h>    

/*
#define TEXT_SIZE_X 256
#define TEXT_SIZE_Y 128
*/

#define TEXT_SIZE_X 1024
#define TEXT_SIZE_Y 512

/**************VIDEO VARIABLES**********************/
VLServer	svr;		/* Video Server */
VLPath		path;		/* Path from camera to mem */
VLNode		src, drn;	/* Nodes, camera and memory buffer */
VLControlValue	val;		/* Video controller information */
VLBuffer	buffer;		/* Video frame buffer */
VLInfoPtr	info;		/* Pointer to Valid camera frame */
char		*data;		/* Pointer to camera data */

/**************GRAPHICS WINDOW VARIABLES*****************/
int		xsize, ysize;	/* Screen Dimensions */
long		win,windim;	/* Graphics window ID, Windows dimensions */
int		spin = 0;
GLdouble	a1 = 0.0;
GLdouble	a2 = 0.0;
GLdouble	a3 = 0.0;
int		cropXmin, cropXmax, cropYmin, cropYmax;
char     	data1[TEXT_SIZE_X * TEXT_SIZE_Y * 4];  /* 4 bytes per pixel */


void
vl_init()
{
    if (!(svr = vlOpenVideo("")))		/* Connect to video daemon */
	exit(0);

    src = vlGetNode(svr, VL_SRC, VL_VIDEO, VL_ANY);	/* open analog node */

    drn = vlGetNode(svr, VL_DRN, VL_MEM, VL_ANY);	/* open memory node */

    path = vlCreatePath(svr, VL_ANY, src, drn);		/* set up paths */

    if ((vlSetupPaths(svr, (VLPathList)&path, 1, VL_SHARE, VL_SHARE)) < 0)
	exit(0);			      	/* set up path to be */
						/* loose */

     val.intVal = VL_PACKING_RGB_8;  		/* 8-bit data */
    /*val.intVal = VL_PACKING_Y_8_IP;*/     /* JUST LUMINANCE? */
    vlSetControl(svr, path, drn, VL_PACKING, &val);

    vlGetControl(svr, path, drn, VL_SIZE, &val);	/* get size of */
                                                        /* frame */
    xsize = val.xyVal.x;
    ysize = val.xyVal.y;
    printf("X %d Y %d\n",xsize, ysize);
    
/*
    cropXmin=0;
    cropXmax=xsize;
    cropYmin=0;
    cropYmax=ysize;
*/  
    cropXmin=246;
    cropXmax=478;
    cropYmin=54;
    cropYmax=231;


    buffer = vlCreateBuffer(svr, path, drn, 1);	/* Create data buffer */
    if (buffer == NULL)
	exit(0);
    
    vlRegisterBuffer(svr, path, drn, buffer);	/* Assign buffer to path */

    if (vlBeginTransfer(svr, path, 0, NULL))
	exit(0);
    
    
}

static void
usage(void)
{
  printf("\n");
  printf("usage: scube [options]\n");
  printf("\n");
  printf("    display a spinning cube and its shadow\n");
  printf("\n");
  printf("  Options:\n");
  printf("    -geometry  window size and location\n");
  printf("    -c         toggle color index mode\n");
  printf("    -l         toggle lighting\n");
  printf("    -f         toggle fog\n");
  printf("    -db        toggle double buffering\n");
  printf("    -logo      toggle sgi logo for the shadow pattern\n");
  printf("    -quads     toggle use of GL_QUADS to draw the checkerboard\n");
  printf("\n");
#ifndef EXIT_FAILURE    /* should be defined by ANSI C
                           <stdlib.h> */
#define EXIT_FAILURE 1
#endif
  exit(EXIT_FAILURE);
}

void		wait_for_frame() {
    long	v[2];
    int		x, y;
    int i = 0;
    int j = 0;
    int yTimesTEXT_SIZE;
    int yTimesXsize;
    
    
    do {
	/*	sginap(1);*/
	info = vlGetLatestValid(svr, buffer);
    } while (!info);			/* wait for valid frame */

    data = vlGetActiveRegion(svr, buffer, info);	/* get screen */
							/* data from */

                                                        /* buffer */
/*    for (i = 0; i < xsize/4; i++)
	for (j = 0; j < ysize/4; j++) {
	    data1[4*(j*256+i)+0] = data[16*(j*xsize+i)+0];
	    data1[4*(j*256+i)+1] = data[16*(j*xsize+i)+1];
	    data1[4*(j*256+i)+2] = data[16*(j*xsize+i)+2];
	    data1[4*(j*256+i)+3] = data[16*(j*xsize+i)+3];
	    
	    
	}
*/
    for (y=  cropYmin; y < cropYmax; y++)
    {
        yTimesTEXT_SIZE = y*TEXT_SIZE_X;
        yTimesXsize = y*xsize;

        for (x = cropXmin; x < cropXmax; x++)
        {
	    data1[(yTimesTEXT_SIZE + x)] = data[4*(yTimesXsize +x)+3];
	}
   }    
    
    glColor3d(0.0,0.0,0.0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

    /*glPixelStorei(GL_UNPACK_ALIGNMENT, 1);*/

    /*glTexImage2D(GL_TEXTURE_2D, 0, 4, TEXT_SIZE_X, TEXT_SIZE_Y, 0, GL_ABGR_EXT*/
    glTexImage2D(GL_TEXTURE_2D, 0, 1, TEXT_SIZE_X, TEXT_SIZE_Y, 0, GL_LUMINANCE

,
		 GL_UNSIGNED_BYTE, data1); 

    glColor3d(0.0,0.5,1.0); 

    /*for (i = -1; i < 2; i++)*/
	/*for (j = -1; j < 2; j++)*/{
	    glPushMatrix();
	    glTranslated(i*4.0, j*4.0, 0.0);
	    /* if (spin) {*/
		glRotated(a1, 1.0, 0.0, 0.0);
		glRotated(a2, 0.0, 0.0, 1.0);
		glRotated(a3, 0.0, 1.0, 0.0);
		/*}*/
	    
    glBegin(GL_QUADS);
	    glTexCoord2d(0.0, 0.0);
	    glVertex3d(-2.0, -2.0, 0.0);
	    glTexCoord2d((GLdouble)xsize/1024.0, 0.0);
	    glVertex3d(2.0, -2.0, 0.0);
	    glTexCoord2d((GLdouble)xsize/1024.0, (GLdouble)ysize/512.0);
	    glVertex3d(2.0, 2.0, 0.0);
	    glTexCoord2d(0.0, (GLdouble)ysize/512.0);
	    glVertex3d(-2.0, 2.0, 0.0);
    glEnd();
	    glPopMatrix();
	    
	}
     
    
    
    /*glRasterPos2d(0.0, 0.0);
    
    glDrawPixels(xsize, ysize, GL_ABGR_EXT, GL_UNSIGNED_BYTE, data);*/

    
/*   Create an 8X8 Grid
    i=0;
    for (i = -2; i < 3; i++) {
    	glBegin(GL_LINES);
		glColor3d(0.0,1.0,0.0); 
		glVertex3d(-2, i, 0);
		glVertex3d(2, i, 0);
		glVertex3d(-2, i+.5, 0);
		glVertex3d(2, i+.5, 0);
		glVertex3d(i, -2, 0);
		glVertex3d(i, 2, 0);
		glVertex3d(i+.5, 2, 0);
		glVertex3d(i+.5, -2, 0);
    	glEnd();  
    }
 */

/*      RGBcolor(255,0,0);  */
/*      bgnline();  */
/*      v[0] = v[1] = 0; v2i(v);  */
/*      v[0] = xsize-1, v[1] = ysize-1; v2i(v);  */
/*      endline();  */
    

    /*glFlush();*/
    /*glutPostRedisplay();*/
    
    /*glFlush();*/
    glutSwapBuffers();
    
    
    vlPutFree(svr, buffer);		/* frame is ready for use again */
}

void
idle(void)
{
    if (spin){
	/*	glRotated(1.4, 1.0, 0.0, 0.0);
	glRotated(0.05, 0.0, 0.0, 1.0);
	glRotated(1.1, 0.0, 1.0, 1.0);*/
	a1 += 1.4;
	a2 += 0.05;
	a3 += 1.1;
	if (a1 >= 360.0) a1 -= 360.0;
	if (a2 >= 360.0) a2 -= 360.0;
	if (a3 >= 360.0) a3 -= 360.0;	
    }
    
    wait_for_frame();
    /*glutPostRedisplay();*/
}

void
keyboard(unsigned char ch, int x, int y)
{
    int cropChange = 3;
    int i;

    if (ch == 'f')
       glRotated(180, 0.0, 1.0, 0.0);

    /*rotate 90 degrees */

    if (ch == 'R')
	glRotated(90.0, 0.0, 0.0, 1.0);
    if (ch == 'r')
	glRotated(1.0, 0.0, 0.0, 1.0);
 
    if (ch == 'm')
	glTranslated(0.0, 0.01, 0.0);
    if (ch == 'M')
	glTranslated(0.0, 0.1, 0.0);
    if (ch == 'i')
	glTranslated(0.0, -0.01, 0.0);
    if (ch == 'I')
	glTranslated(0.0, -0.1, 0.0);
     if (ch == 'k')
	glTranslated(0.01, 0.0, 0.0);
     if (ch == 'K')
	glTranslated(0.1, 0.0, 0.0);
     if (ch == 'j')
	glTranslated(-0.01, 0.0, 0.0);
     if (ch == 'J')
	glTranslated(-0.1, 0.0, 0.0);

    if (ch == ',')
	glScaled(1.01, 1.01, 1.01);
    if (ch == '>')
	glScaled(1.1, 1.1, 1.1);
    if (ch == '.')
	glScaled(0.99, 0.99, 0.99);
    if (ch == '<')
	glScaled(0.9, 0.9, 0.9);

    if (ch == 'a')
    {
       cropXmin += cropChange;
       if(cropXmin > xsize) cropXmin = xsize;
    }

    if (ch == 'z')
    {
       cropXmin -= cropChange;
       if(cropXmin < 0) cropXmin = 0;
    }

    if (ch == 's')
    {
       cropXmax += cropChange;
       if(cropXmax > xsize) cropXmax = xsize;
    }

    if (ch == 'x')
    {
       cropXmax -= cropChange;
       if(cropXmax < 0) cropXmax = 0;
    }

    if (ch == 'd')
    {
       cropYmin += cropChange;
       if(cropYmin > ysize) cropYmin = ysize;
    }

    if (ch == 'c')
    {
       cropYmin -= cropChange;
       if(cropYmin < 0) cropYmin = 0;
    }

    if (ch == 'f')
    {
       cropYmax += cropChange;
       if(cropYmax > ysize) cropYmax = ysize;
    }

    if (ch == 'v')
    {
       cropYmax -= cropChange;
       if(cropYmax < 0) cropYmax = 0;
    }
   
    if (ch == '?')
    {
       printf("menu\n");
       printf("m -- translates the image __\n");
       printf("i -- translates the image __\n");
       printf("k -- translates the image __\n");
       printf("j -- translates the image __\n");
       printf("R -- rotates the image CCW 90 degrees/n");
       printf("r -- rotates the image CCW  1 degrees/n");
       
    }

    printf("Left Crop = %i 	Rigth Crop = %i 		Bottom Crop= %i 		Top Crop = %i \n", 
    cropXmin, cropXmax, cropYmin, cropYmax);
   
    for(i=0; i<TEXT_SIZE_X*TEXT_SIZE_Y*4; ++i) data1[i]=0;
}

void		close_video() {
    vlEndTransfer(svr, path);
    vlDeregisterBuffer(svr, path, drn, buffer);
    vlDestroyBuffer(svr, buffer);
    vlDestroyPath(svr, path);
    vlCloseVideo(svr);
}

void
display(void)
{
    glutSwapBuffers();

}

void
menu_select(int mode)
{
  switch (mode) {
  case 1: 
      glLoadIdentity();
      glRotated(180.0, 1.0, 0.0, 0.0);
      spin = 0;
      a1 = a2 = a3 = 0.0;
      system("killall playaifc &");
      
      break;
  case 2: 
      spin = !spin;
      if (spin)
	  system("playaifc /usr0/ajl/data/danube.aifc &");
      else
	  system("killall playaifc &");
      
      break;
  
      /*     moving = 1; */
/*     glutIdleFunc(idle); */
/*     break; */
/*   case 2: */
/*     moving = 0; */
/*     glutIdleFunc(NULL); */
/*     break; */
/*   case 3: */
/*     useFog = !useFog; */
/*     useFog ? glEnable(GL_FOG) : glDisable(GL_FOG); */
/*     glutPostRedisplay(); */
/*     break; */
/*   case 4: */
/*     useLighting = !useLighting; */
/*     useLighting ? glEnable(GL_LIGHTING) : */
/*       glDisable(GL_LIGHTING); */
/*     glutPostRedisplay(); */
/*     break; */
  case 666:
      close_video();
      system("killall playaifc &");
      exit(0);
      break;
  }
}

int
main(int argc, char **argv)
{
  int menu;

  system("videoout -nocontrol -geometry +6+33");

  vl_init();
  glutInitWindowPosition(0, 0);
  glutInitWindowSize(xsize, ysize);
  
  glutInit(&argc, argv);

  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);

  win = glutCreateWindow("Sonic Flashlight(TM)");

  glutKeyboardFunc(keyboard);
  glutDisplayFunc(wait_for_frame);
  glutIdleFunc(idle);
  
  menu = glutCreateMenu(menu_select);
  glutAddMenuEntry("Reset", 1);
  glutAddMenuEntry("Toggle Spin", 2);
  glutAddMenuEntry("Quit", 666);
  glutAttachMenu(GLUT_RIGHT_BUTTON);

  /* setup context */
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  /*glOrtho(0.0, (GLdouble)512, 0.0, (GLdouble)256, -1.0, 1.0);*/
  glFrustum(-2.0, 2.0, -2.0, 2.0, 10.0, 30.0);
  glTranslated(0.0, 0.0, -20.0);

/*

  Create a window for image dimensions 
  windim = XCreateSimpleWindow("Window", win,10,10,10,10,
           0, 4, 256);
  windim.open();

*/

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glRotated(180.0, 1.0, 0.0, 0.0);
  
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER,
        GL_NEAREST);
    glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, 
        GL_NEAREST);
    glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE_EXT);
    glEnable(GL_TEXTURE_2D);
    glShadeModel(GL_FLAT);

  
  glClearColor(0.0, 0.0, 0.0, 1);
  glClearIndex(0);
  glClearDepth(1);

  glutMainLoop();
  return 0;             /* ANSI C requires main to return int. */
}









